#include <sfml\Graphics.hpp>
#include <iostream>

int main()
{
    sf::Vector2u renderWindowSize{1024u,512u};
    sf::RenderWindow window(sf::VideoMode(1024, 512), "SFML Animation Demonstration", sf::Style::Close);
    sf::Event evnt;
    auto loopCounter = 0u;
    auto textureIndex = 0;

    bool pauseFlag = false;

    // Create moving sprite
    sf::Vector2f textureSize= {256.f,256.f};

    sf::Texture texture;
    texture.loadFromFile("runningcat256.png");

    sf::Vector2i textureLocation[8] = {{0,0},{128,0},{0,64},{128,64},{0,128},{128,128},{0,192},{128,192}};

    sf::IntRect locationInTexture;
    locationInTexture.width = static_cast<int>(textureSize.x/2);
    locationInTexture.height = static_cast<int>(textureSize.y/4);
    locationInTexture.left = textureLocation[textureIndex].x;
    locationInTexture.top = textureLocation[textureIndex].y;

    sf::Sprite cat(texture);
    auto spriteXPosition = 0.0f;
    sf::Vector2f spritePosition = {spriteXPosition,renderWindowSize.y/2.0f};
    cat.setOrigin(cat.getLocalBounds().width/4.0f,cat.getLocalBounds().height/8.0f);
    cat.setPosition(spritePosition);
    cat.setTextureRect(locationInTexture);

    // text
    sf::Font font;
    font.loadFromFile("arial.ttf");
    sf::Text text(sf::String("  Press Escape to pause the cat, Q to quit"),font);
    text.setFillColor(sf::Color::Yellow);
    text.setPosition(240.0f,450.0f);

    while (window.isOpen())
    {
        loopCounter++;
        if (!pauseFlag && !(loopCounter%100))
        {
            textureIndex = ++textureIndex < 8 ? textureIndex : 0;
            locationInTexture.left = textureLocation[textureIndex].x;
            locationInTexture.top = textureLocation[textureIndex].y;
            cat.setTextureRect(locationInTexture);
            spriteXPosition += 32.0f;
            spriteXPosition = spriteXPosition > 1024.0f ? 0.0f : spriteXPosition;
            spritePosition.x = spriteXPosition;
            cat.setPosition(spritePosition);
        }
        while (window.pollEvent(evnt))
        {
            switch (evnt.type)
            {
            case sf::Event::Closed:
                window.close();
                break;
            case sf::Event::KeyPressed:
                if (sf::Keyboard::isKeyPressed(sf::Keyboard::Escape))
                {
                        pauseFlag = !pauseFlag;
                        if (pauseFlag) text.setString("Press Escape to continue running, Q to quit");
                        else text.setString("  Press Escape to pause the cat, Q to quit");
                }
                if (sf::Keyboard::isKeyPressed(sf::Keyboard::Q)) window.close();
            default:
                ;
            }
            if (evnt.type == evnt.Closed)
            {
                window.close();
            }
        }
        window.clear();
        window.draw(cat);
        window.draw(text);
        window.display();
    }
}
